/* Generated file -- DO NOT EDIT */

package hI.dQComponents.email;

/**
 * Checks if the email address is formatted correctly and
 * if the domain in the email address exists (optional).
 * The domain check requires a license. If the license file is not present,
 * the domain check is not executed.
 */
public interface Validator extends hI.DQComponent {
	
	/**
	 * Calls HIquality Email Validation.
	 * Note: the output parameters need to be declared in variables of the Holder type before calling this method.
	 * @param emailAddress Input parameter: the complete email address to be checked, e.g.:
	 * <i>Anna Maria Schmidt <a.m.schmidt@example.net></i> or: <i>peter.smith@example.com</i>.
	 * @param reliability Output parameter: a code signifying the reliability of the email address.
	 * @param emailDetails Output parameter: the constituent parts of the email address.
	 * @param functionalStatus Output parameter: the general status code and status messages.
	 */
	void Validate(java.lang.String emailAddress,
		ilona.Int.Holder reliability,
		hI.dQComponents.email.EmailDetails.Holder emailDetails,
		hI.Status.Holder functionalStatus);
	
	public static final class Marshaller {
		
		private Marshaller()
		{
		}
		
		public static void Validate(Validator target_,
			java.lang.String emailAddress,
			ilona.Int.Holder reliability,
			hI.dQComponents.email.EmailDetails.Holder emailDetails,
			hI.Status.Holder functionalStatus)
		{
			ilona.RequestWriter writer_ = new ilona.RequestWriter(
				target_.getObjectReference_(),
				"Validate");
			
			writer_.writeString(emailAddress);
			
			ilona.Reader reader_;
			try {
				reader_ = writer_.execute();
			} catch (ilona.UserException ex_) {
				throw new ilona.Unexpected(ex_);
			}
			
			reliability.value = reader_.readInt();
			emailDetails.value = hI.dQComponents.email.EmailDetails.read_(reader_);
			functionalStatus.value = hI.Status.read_(reader_);
			
			reader_.readEndOfMessage();
		}
	}
	
	public static final class Factory {
		
		private static final class Proxy extends ilona.Object.Proxy
			implements Validator {
			
			public Proxy(ilona.ObjectReference ref)
			{
				super(ref);
			}
			
			public java.lang.String[] GetAllStatusCodes()
			{
				return hI.DQComponent.Marshaller.GetAllStatusCodes(
					this);
			}
			
			public java.lang.String GetMainMethod()
			{
				return hI.DQComponent.Marshaller.GetMainMethod(
					this);
			}
			
			public java.lang.String[] GetStatusFields()
			{
				return hI.DQComponent.Marshaller.GetStatusFields(
					this);
			}
			
			public hI.DQComponent.Version GetVersion()
			{
				return hI.DQComponent.Marshaller.GetVersion(
					this);
			}
			
			public void Validate(java.lang.String emailAddress,
				ilona.Int.Holder reliability,
				hI.dQComponents.email.EmailDetails.Holder emailDetails,
				hI.Status.Holder functionalStatus)
			{
				hI.dQComponents.email.Validator.Marshaller.Validate(
					this, emailAddress, reliability, emailDetails, functionalStatus);
			}
		}
		
		
		private Factory()
		{
		}
		
		public static Validator createProxy(ilona.ObjectReference ref)
		{
			return ref != null ? new Proxy(ref) : null;
		}
		
		public static Validator createProxy(java.lang.String url) throws
			ilona.Url2ObjectError
		{
			
			ilona.Object obj = 
				ilona.Object.Factory.createProxy(url);
			Validator result = narrow(obj);
			
			if (obj != null && result == null) {
				throw new java.lang.ClassCastException(
					"type mismatch casting url " + 
					url + " to ilona interface " + 
					"::HI::DQComponents::Email::Validator");
			}
			
			return result;
		}
		
		/**
		 * Returns a proxy of the interface <code>Validator</code>.
		 * Checks if the remote servant supports the <code>Validator</code> interface.
		 * If so, it returns a <code>Validator</code> proxy. If not, it returns null.
		 * @param forObject proxy of the remote ilona object
		 * @return proxy of the interface
		 */
		public static Validator narrow(ilona.Object forObject)
		{
			Validator result;
			
			if (forObject == null) {
				result = null;
			} else if (forObject instanceof Validator) {
				result = (Validator) forObject;
			} else if (forObject.isA_("::HI::DQComponents::Email::Validator")) {
				result = createProxy(
					forObject.getObjectReference_());
			} else {
				result = null;
			}
			
			return result;
		}
	}
	
	public static final class Holder {
		
		public hI.dQComponents.email.Validator value;
		
		public Holder()
		{
			value = null;
		}
		
		public Holder(hI.dQComponents.email.Validator initialValue)
		{
			value = initialValue;
		}
	}
}
